
//==== Includes

//-- sytem

#include <fstream>
using std::ifstream;
using std::ofstream;
using std::ios;

//-- self

#include "Types.h"
#include "str.h"
#include "data.h"
#include "io.h"


//==== Functions

bool readstream(istream& is, data& get)
{
	char info;
	while (is.get(info))
	{
		get << char_to_byte(info);
	}
	is.clear();
	return bool(get);
}

bool writestream(ostream& os, data& dest)
{
	byte info;
	while (bool(dest >> info))
	{
		os << byte_to_char(info);
	}
	dest.fail = false;
	return bool(dest);
}

bool readfile(const char* path, data& get)
{
	istream *in;
	ifstream fin;
	if (strequal(path, "."))
	{
		in = &std::cin;
	}
	else
	{
		fin.open(path, ios::in | ios::binary);
		if (!bool(fin)) return false;
		in = &fin;
	}
	return readstream(*in, get);
}

bool writefile(const char* path, data& put)
{
	ostream *out;
	ofstream fout;
	if (strequal(path, "."))
	{
		out = &std::cout;
	}
	else
	{
		fout.open(path, ios::out | ios::binary | ios::trunc);
		if (!bool(fout)) return false;
		out = &fout;
	}
	return writestream(*out, put);
}
