
//==== Includes

//-- self

#include "str.h"


//==== Functions

int str_to_int(const char* text)
{
	if (*text == '\0') return 0;

	char c = *text++;

	int sign = 1;
	if (c == '-')
		sign = -1;
	else if (c != '+')
		text--;

	int value = 0;

	while ((c = *text++) != '\0')
	{
		int digit = int(c - '0');
		if (digit >= 0 && digit < 10)
		{
			value = value * 10 + digit;
		}
		else
		{
			break;
		}
	}

	return sign * value;
}
